<?php
/*------------------------------------------------------------------------------
  $Id$

  AbanteCart, Ideal OpenSource Ecommerce Solution
  http://www.AbanteCart.com

  Copyright © 2011 Belavier Commerce LLC

  This source file is subject to Open Software License (OSL 3.0)
  License details is bundled with this package in the file LICENSE.txt.
  It is also available at this URL:
  <http://www.opensource.org/licenses/OSL-3.0>

 UPGRADE NOTE:
   Do not edit or add to this file if you wish to upgrade AbanteCart to newer
   versions in the future. If you wish to customize AbanteCart for your
   needs please refer to http://www.AbanteCart.com for more information.
------------------------------------------------------------------------------*/
if (! defined ( 'DIR_CORE' ) || !IS_ADMIN) {
	header ( 'Location: static_pages/' );
}
class ControllerResponsesListingGridRewardPointsHistory extends AController {
	private $error = array ();

	public function main() {
		//init controller data
		$this->extensions->hk_InitData($this,__FUNCTION__);

		$this->loadLanguage('reward_points/reward_points');
		if (! $this->user->canAccess('extension/reward_points' )) {
			$response = new stdClass();
			$response->userdata->error = sprintf( $this->language->get( 'error_permission_access' ), 'extension/reward_points' );
			$this->load->library('json');
			$this->response->setOutput(AJson::encode($response));
			return;
		}

		$this->loadModel ( 'extension/reward_points' );

		$page = $this->request->post ['page']; // get the requested page
		$limit = $this->request->post ['rows']; // get how many rows we want to have into the grid
		$sidx = $this->request->post ['sidx']; // get index row - i.e. user click to sort
		$sord = $this->request->post ['sord']; // get the direction

		$filter = array();
		//process custom search form
		$allowedSearchFilter = array ('date_added', 'points_amount','action_type', 'source' );

		$total = $this->model_extension_reward_points->getHistoryTotalRows ( $this->request->get['customer_id'] );
		if ($total > 0) {
			$total_pages = ceil ( $total / $limit );
		} else {
			$total_pages = 0;
		}

		$response = new stdClass ();
		$response->page = $page;
		$response->total = $total_pages;
		$response->records = $total;

		$results = $this->model_extension_reward_points->getHistory ( $this->request->get['customer_id'], ($page - 1) * $limit, $limit );

		$i = 0;

		$action_types = array(
			'I' => 'text_increased',
			'D' => 'text_decreased',
			'M' => 'text_manual_set'
		);

		foreach ( $results as $k=>$result ) {

			$k++;
			$response->rows [$i] ['id'] = $k;

			$response->rows [$i] ['cell'] = array(
				$k,
				$result ['date'],
				$result ['amount'],
				$this->language->get($action_types[$result['action']]),
				$result ['source'],
				$result ['comment'],
			);

			$i ++;
		}

		//update controller data
		$this->extensions->hk_UpdateData($this,__FUNCTION__);

		$this->load->library('json');
		$this->response->setOutput(AJson::encode($response));

	}

}