<?php
	/*------------------------------------------------------------------------------
   $Id$

   AbanteCart, Ideal OpenSource Ecommerce Solution
   http://www.AbanteCart.com

   Copyright © 2011 Belavier Commerce LLC

   This source file is subject to Open Software License (OSL 3.0)
   License details is bundled with this package in the file LICENSE.txt.
   It is also available at this URL:
   <http://www.opensource.org/licenses/OSL-3.0>

  UPGRADE NOTE:
	Do not edit or add to this file if you wish to upgrade AbanteCart to newer
	versions in the future. If you wish to customize AbanteCart for your
	needs please refer to http://www.AbanteCart.com for more information.
 ------------------------------------------------------------------------------*/
	if (!defined('DIR_CORE')) {
		header('Location: static_pages/');
	}

class ModelExtensionRewardPoints extends Model {

	public function getRewardPoints($customer_group_id = null, $object_name = null, $object_id = null) {
		$q = 'SELECT * FROM ' . DB_PREFIX . 'reward_points';

		$where = array();
		if ( $object_name ) {
			$where[] = 'object_name = "' . $this->db->escape($object_name) . '"';

			if ( $object_id ) {
				$where[] = 'object_id = ' . (int) $object_id;
			}
		}

		if ($customer_group_id) {
			$where[] = 'customer_group_id = ' . (int) $customer_group_id;
		}

		if ( !empty($where) ) {
			$q .= ' WHERE ' . implode(' AND ', $where);
		}

		$result = $this->db->query($q);

		return $result->rows;
	}

	public function addRewardPoints($data) {

		if ( !isset($data['amount']) ) {
			$data['amount'] = 0;
		}

		if ( !isset($data['amount_modificator']) ) {
			$data['amount_modificator'] = 'a';
		}

		if ( !isset($data['combine']) ) {
			$data['combine'] = 1;
		}

		$q = 'INSERT INTO ' . DB_PREFIX . 'reward_points
			SET
			customer_group_id = "' . (int) $data['customer_group_id'] . '",
			amount = "' . (int) $data['amount'] . '",
			amount_modificator = "' . $this->db->escape($data['amount_modificator']) . '",
			combine = "' . (int) $data['combine'] . '",
			object_id = "' . (int) $data['object_id'] . '",
			object_name = "' . $this->db->escape($data['object_name']) . '"';

		return $this->db->query($q);
	}

	public function updateRewardPoints($data) {

		if ( !isset($data['amount']) && !isset($data['amount_modificator']) && !isset($data['combine']) ) {
			return;
		}

		$q = 'UPDATE ' . DB_PREFIX . 'reward_points';

		$cols = array();
		if ( isset($data['amount']) ) {
			$cols['amount'] = 'amount = "' . (int) $data['amount'] . '"';
		}

		if ( isset($data['amount_modificator']) ) {
			$cols['amount_modificator'] = 'amount_modificator = "' . $this->db->escape($data['amount_modificator']) . '"';
		}

		if ( isset($data['combine']) ) {
			$cols['combine'] = 'combine = "' . (int) $data['combine'] . '"';
		}

		$q .= ' SET ' . implode(',', $cols);

		if ( isset($data['reward_point_id']) ) {
			$q .= ' WHERE reward_point_id = "' . (int) $data['reward_point_id'] . '"';
		} else {
			$q .= ' WHERE object_name = "' . $this->db->escape($data['object_name']) . '"
					AND object_id = "' . (int) $data['object_id'] . '"';
		}

		if ( isset($data['customer_group_id']) ) {
			$q .= ' AND customer_group_id = "' . (int) $data['customer_group_id'] . '"';
		}

		return $this->db->query($q);
	}

	public function removeRewardPoints($data) {
		if ( ( !isset($data['object_name']) || !isset($data['object_id']) ) && !isset($data['reward_point_id']) ) {
			return;
		}

		$q = 'DELETE FROM ' . DB_PREFIX . 'reward_points';

		if ( isset($data['reward_point_id']) ) {
			$q .= ' WHERE reward_point_id = "' . (int) $data['reward_point_id'] . '"';
		} else {
			$q .= ' WHERE object_name = "' . $this->db->escape($data['object_name']) . '"
					AND object_id = "' . (int) $data['object_id'] . '"';
		}

		return $this->db->query($q);
	}

	public function getCustomerRewardPoints($customer_id) {
		$result = $this->db->query('
			SELECT * FROM ' . DB_PREFIX . 'reward_points_customers
			WHERE customer_id = "' . (int) $customer_id . '" LIMIT 1'
		);

		if ( $result->num_rows > 0 ) {
			return $result->row;
		}
		return array();
	}

	public function setCustomerRewardPoints($customer_id, $points_amount) {

		return $this->db->query('
			REPLACE INTO ' . DB_PREFIX . 'reward_points_customers
			SET
				customer_id = "' . (int) $customer_id . '",
				points_amount = "' . (int) $points_amount. '",
				date_modified = NOW()
		');
	}

	public function updateHistory($data) {
		return $this->db->query('
			INSERT INTO ' . DB_PREFIX . 'reward_points_history
			SET
				customer_id = "' . (int) $data['customer_id'] . '",
				amount = "' . (int) $data['amount'] . '",
				action = "' . $this->db->escape($data['action']) . '",
				source = "' . $this->db->escape($data['source']) . '",
				source_id = "' . (int) $data['source_id'] . '",
				comment = "' . $this->db->escape($data['comment']) . '",
				date = NOW()
		');
	}

	public function setRewardPointsOrder($data) {
		return $this->db->query(
			'INSERT INTO ' . DB_PREFIX . 'reward_points_orders
			SET
				order_id = "' . (int)$data['order_id'] . '",
				amount = "' . (int)$data['amount'] . '",
				action = "' . $this->db->escape($data['action']) . '"');
	}

	public function getRewardPointsOrder($order_id) {
		$result = $this->db->query(
			'SELECT * FROM ' . DB_PREFIX . 'reward_points_orders
			WHERE order_id = "' . (int)$order_id . '"'
		);

		if ( $result->num_rows ) {
			return $result->row;
		}
		return array();
	}

	public function getHistory($customer_id, $start = 0, $limit = 20) {

		if ($start < 0) {
			$start = 0;
		}

		$q = 'SELECT * FROM ' . DB_PREFIX . 'reward_points_history
			WHERE customer_id = "' . (int) $customer_id . '"
			ORDER BY date DESC
			LIMIT ' . (int) $start . ', ' . (int) $limit;

		$result = $this->db->query($q);

		if ( $result->num_rows ) {
			return $result->rows;
		}
		return array();
	}

	public function getHistoryTotalRows($customer_id) {

		$result = $this->db->query(
			'SELECT COUNT(reward_points_history_id) as count
  			FROM ' . DB_PREFIX . 'reward_points_history
  			WHERE customer_id = "' . (int) $customer_id . '"'
		);
		if ( $result->num_rows ) {
			return (int) $result->row['count'];
		}
		return 0;
	}

}